<template>
    <div
        ref="contentEditableRef"
        class="omm-content-editable"
        v-bind="$attrs"
        :contenteditable="value"
        @input="$emit('input', value)"
        @dblclick="handleDoubleClick"
        @blur="handleBlur"
        @keydown="handleKeydown"
        @focus="handleFocus"
    >{{ text }}</div>
</template>

<script lang="ts">
import { KeyboardEventExtended } from '@/ts';
import { defineComponent, nextTick, onBeforeMount, onUpdated, Ref, ref, set, toRefs } from '@vue/composition-api'
import { makeElementSelectable } from "@/utils";

/**
 * @emits becomeNonEditable
 */
export default defineComponent({
    name: 'ContentEditable',
    props: {
        initialValue: {
            type: String,
            default: ''
        },
        itemKey: {
            type: String,
            required: true
        },
        action: {
            type: String,
            default: ''
        },
        value: {
            type: Boolean,
            default: false
        }
    },
    setup(props, { emit }) {
        const { initialValue, itemKey } = toRefs(props);
        const text: Ref<string> = ref('');
        const isEditable: Ref<boolean> = ref(false);
        const contentEditableRef: Ref<HTMLElement|undefined> = ref();

        const makeNonEditable = async () => {
            emit('input', false);

            await nextTick();

            const editableElement = contentEditableRef.value as HTMLElement;

            emit('becomeNonEditable', editableElement.innerText);
        }

        const makeEditable = async () => {
            emit('input', true);

            await nextTick();

            if (!contentEditableRef.value) return;

            const contentEditableEl = contentEditableRef.value as HTMLElement;

            makeElementSelectable(contentEditableEl);

            emit('becameEditable', { text, contentEditableRef });
        }

        const applyInitialValue = () => {
            text.value = initialValue.value.replace('forceUpdate::', '');
        }

        const handleDoubleClick = () => {
           if (!props.value) makeEditable();
        }

        const handleBlur = async () => {
            const contentEditable = contentEditableRef.value;
            await makeNonEditable();
            emit('blur', contentEditable && contentEditable.innerText);
        }

        const handleFocus = () => {
            const contentEditable = contentEditableRef.value;
            emit('input', true);
            emit('focus', contentEditable && contentEditable.innerText);
        }

        const handleEnter = () => {
            const contentEditable = contentEditableRef.value;
            makeNonEditable();
            contentEditable && contentEditable.blur();
        }

        /**
         * Handles escape keydown event by restoring initial value and making item no longer editable.
         * @param e
         */
        const handleEscape = async () => {
            text.value = initialValue.value;

            emit('input', false);

            if (contentEditableRef.value) {
                contentEditableRef.value.innerText = initialValue.value;
            }
        }

        const handleKeydown = (event: KeyboardEventExtended) => {
            if (event.key !== 'Escape') {
                const newValue = contentEditableRef.value ? contentEditableRef.value.innerText : '';
                const oldValue = initialValue || '';

                set(event, 'newValue', newValue);
                set(event, 'oldValue', oldValue);
                set(event, 'vueComponentKey', itemKey && itemKey.value);
            }

            emit('keydown', event);

            switch (event.key) {
                case 'Enter':
                    event.preventDefault();
                    handleEnter();
                    break;
                case 'Escape':
                    handleEscape();
                    break;
            }
        }

        onBeforeMount(() => {
            applyInitialValue();
        });

        onUpdated(() => {
            applyInitialValue();
        });

        return { text, isEditable, handleDoubleClick, handleBlur, handleFocus, handleKeydown, contentEditableRef }
    }
})
</script>

<style lang="scss" scoped>
.omm-content-editable {
    user-select: none;
    max-width: 100%;
    white-space: nowrap;
    overflow: hidden;
    text-overflow: ellipsis;
}
</style>
